#!/usr/bin/env node
import l from "node:path";
import u from "node:fs";
import A from "json5";
import v from "lodash.upperfirst";
import x from "lodash.camelcase";
import $ from "lodash.kebabcase";
import L from "lodash.lowerfirst";
import f from "lodash.template";
import { log as m, chalk as g, xPrompts as S, createSubcommand as w, createMainCommand as k } from "@done-coding/cli-utils";
import { OutputModeEnum as h, handler as y } from "@done-coding/cli-template";
import D from "lodash.curry";
var a = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(a || {});
const T = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return m.error("组件名只能包含字母、数字、中划线"), process.exit(1);
  const { nameExcludes: n } = t;
  return n.includes(e) ? (m.error(`组件名: ${e}是保留名称。
保留名称: ${n.join(",")}`), process.exit(1)) : !0;
}, M = {
  version: "0.3.1-alpha.0",
  name: "@done-coding/cli-component",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: _, moduleName: j } = M.cliConfig, I = () => l.resolve(_, j), N = () => ({
  execDir: process.cwd(),
  templateDir: I()
}), d = (e) => {
  const { series: t, name: n } = e, r = v(x(n)), i = L(r), s = $(r), c = t ? v(x(t)) : "", o = c ? `${c}${r}` : "", p = $(o);
  return {
    series: c,
    name: r,
    nameLowerFirst: i,
    nameKebab: s,
    fullName: o,
    fullNameKebab: p,
    cls: p
  };
}, F = (e) => ({
  $: "$",
  ...N(),
  ...d(e)
}), C = () => {
  const e = l.resolve(I(), "index.json");
  if (!u.existsSync(e))
    return m.error(`模块入口文件不存在: ${e}`), process.exit(1);
  const n = JSON.parse(u.readFileSync(e, "utf-8")).config;
  if (!n)
    return m.error(`配置文件相对路径不存在: ${n}`), process.exit(1);
  const r = l.resolve(
    l.dirname(e),
    n
  );
  if (!u.existsSync(r))
    return m.error(`配置文件不存在: ${r}`), process.exit(1);
  const i = A.parse(u.readFileSync(r, "utf-8")), s = N();
  return i.componentDir = f(i.componentDir)(s), i;
}, b = (e) => {
  const { componentDir: t, nameExcludes: n } = e;
  return u.statSync(t).isDirectory() ? u.readdirSync(t).map((c) => {
    const o = l.join(t, c);
    return u.statSync(o).isDirectory() ? (console.log("filePath:", o, l.basename(o)), l.basename(o)) : "";
  }).filter((c) => !(!c || n.includes(c))) : (m.error("组件源码路径不是目录"), process.exit(1));
}, K = async () => {
  m.stage("展示列表");
  const e = C(), t = b(e);
  console.table(
    t.map((n) => {
      const { name: r, fullName: i } = d({
        ...e,
        name: n
      });
      return {
        [g.green("名称")]: r,
        [g.green("带系列名称")]: i,
        [g.green("绝对路径")]: l.resolve(e.componentDir, n)
      };
    })
  );
}, R = async ({
  name: e,
  config: t,
  command: n
}) => {
  if (![a.ADD, a.REMOVE].includes(n))
    return m.error(`不支持组件${n}操作`), process.exit(1);
  const r = F({
    ...t,
    name: e
  }), i = JSON.stringify(r);
  for (const { entry: s, index: c } of t.list) {
    if (s) {
      const o = s;
      o != null && o.input && (o.input = f(o.input)(r)), o != null && o.output && (o.output = f(o.output)(r));
      const p = {
        ...s,
        envData: i,
        mode: h.APPEND,
        rollback: n === a.REMOVE,
        dealMarkdown: !0
      };
      await y(p);
    }
    if (c) {
      const o = c;
      o != null && o.input && (o.input = f(o.input)(r)), o != null && o.output && (o.output = f(o.output)(r));
      const p = {
        ...c,
        envData: i,
        mode: h.OVERWRITE,
        rollback: n === a.REMOVE,
        dealMarkdown: !0
      };
      await y(p);
    }
  }
}, z = async ({ name: e }) => {
  m.stage("添加组件");
  let t;
  e ? t = e : t = (await S({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const n = C();
  T(t, n);
  const { series: r } = n, i = await b(n);
  for (let s of i)
    if (d({
      series: r,
      name: t
    }).nameKebab === s)
      return m.error(`组件${s}已存在, 不能再次创建${t}组件`), process.exit(1);
  return R({
    name: t,
    config: n,
    command: a.ADD
  });
}, J = async ({ name: e }) => {
  m.stage("移除组件");
  const t = C(), n = await b(t);
  if (n.length === 0)
    return m.error("组件列表为空"), process.exit(1);
  let r;
  e ? r = e : r = (await S({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: n.map((s) => ({ title: s, value: s }))
  })).name;
  const { series: i } = t;
  for (let s of n)
    if (d({
      series: i,
      name: r
    }).nameKebab === s) {
      await R({
        name: r,
        config: t,
        command: a.REMOVE
      }), u.rmdirSync(l.resolve(t.componentDir, s));
      return;
    }
  return m.error(`组件${r}不存在`), process.exit(1);
}, E = async (e, t) => e === a.ADD ? z(t) : e === a.REMOVE ? J(t) : e === a.LIST ? K() : (m.error(`无效的命令: ${e}`), process.exit(1)), {
  version: Z,
  description: U,
  cliConfig: { moduleName: O }
} = M, W = {
  command: `${a.ADD} <name>`,
  describe: "新增一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: D(E)(a.ADD)
}, q = {
  command: `${a.REMOVE} [name]`,
  describe: "删除一个组件",
  positionals: {
    name: {
      describe: "组件名称",
      type: "string"
    }
  },
  handler: D(E)(a.REMOVE)
}, B = {
  command: a.LIST,
  describe: "展示组件列表",
  handler: D(E)(a.LIST)
}, P = {
  describe: U,
  version: Z,
  subcommands: [
    W,
    q,
    B
  ].map((e) => w(e)),
  demandCommandCount: 1
}, V = (e = !1) => {
  const t = e ? O : void 0, n = `$0${e ? ` ${O}` : ""} <command> [options]`;
  return { command: t, usage: n };
}, ie = async () => k({
  ...P,
  ...V()
}), ce = () => w({
  ...P,
  ...V(!0)
});
export {
  ce as a,
  ie as c,
  E as h
};
